unit KrapD6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,registry;

type
  TForm1 = class(TForm)
    Edit2: Tedit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    Function RegGetBinary: String;
    Procedure ShowCdKey;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Reg: TRegistry;
  HexStr,KeyName: String;  
const
HKLM = HKEY_LOCAL_MACHINE;
//Keyname = 'SOFTWARE\Microsoft\Office\10.0\Registration\{90280410-6000-11D3-8CFE-0050048383C9}';
DPID = 'DigitalProductId';
PID = 'ProductID';
PN = 'ProductName';
implementation
uses
Scanf;
{$R *.dfm}
Function TForm1.RegGetBinary: String;
var
  Buffer: array of Byte;
  BufferSize, k: Integer;
  ID: Dword;
  IDATE: TDAteTime;
  AFOSVersionInfo: TOSVersionInfo;
begin
  AFOSVersionInfo.dwOSVersionInfoSize := SizeOf(AFOSVersionInfo);
  GetVersionEx(AFOSVersionInfo);
  case AFOSVersionInfo.dwPlatformId of
      VER_PLATFORM_WIN32_WINDOWS:   KeyName :='SOFTWARE\MICROSOFT\Windows\CurrentVersion';
      VER_PLATFORM_WIN32_NT:        KeyName :='SOFTWARE\MICROSOFT\Windows NT\CurrentVersion';
  end;
  Reg := TRegistry.Create;
  Reg.RootKey := HKLM;
  Reg.OpenKey(KeyName, false);
  BufferSize := reg.GetDataSize(DPID);
  SetLength(Buffer,BufferSize);
  Label4.Caption := Reg.ReadString(PN);
  Label5.Caption := Reg.ReadString(PID);
  case AFOSVersionInfo.dwPlatformId of
      VER_PLATFORM_WIN32_WINDOWS:   begin
                                    ID := $210000;
				                        IF (Reg.GetDataType('FirstInstallDateTime') = rdBinary) AND
					                     (Reg.GetDataSize('FirstInstallDateTime') = SizeOf(ID)) THEN
                                       begin
                                       Reg.ReadBinaryData('FirstInstallDateTime',ID, SizeOf(ID));
                                       Label6.Caption := FormatDateTime('dd/mm/yyyy',
                                                                        FileDateToDateTime(id));
                                       end;
                                    end;
		VER_PLATFORM_WIN32_NT:        begin
                                    ID := Reg.ReadInteger('InstallDate');
                                    IDate := EncodeDate(1970,1,1) + ID/86400;
                                    label6.Caption := DateToSTr(IDate);
                                    end;
  end;

  reg.ReadBinaryData(DPID, Buffer[0], BufferSize); {read in the data, treat as pchar}
  reg.CloseKey;
  Reg.Free;
  for k := 0 to BufferSize - 1 do
  HExStr := HexSTr+IntToHex((Buffer[k]), 2);
  result := Copy(HexStr,105,30);
end;

function DecodeProdKEy(des,src: PChar; dlen,slen: Integer): Integer;
const   digits:     PChar = 'BCDFGHJKMPQRTVWXY2346789';
var     i:          Integer;
        n:          Integer;
        _hi:        Integer;
        _low:       Integer;
        value:      Integer;
begin
  ZeroMemory(des, dlen);
  for i:=Pred(dlen) downto 0 do
  begin
     if (((i+1) mod 6) = 0) then
     begin
        des[i]:='-';
        des[dlen]:=#0;
     end
     else
     begin
        n:=slen-1;
        _hi:=0;
        repeat
           _low:=Ord(src[n]);
           value:=_hi shl 8;
           value:=value or _low;
         // This makes no sense ??? 2 assigments
         //  src[n]:=Chr(value mod 24);
           src[n]:=Chr(value div 24);
           _hi:=value mod 24;
           dec(n);
        until (n < 0);
        des[i]:=digits[value mod 24];
        des[dlen]:=#0;
     end;
  end;
  result:=0;

end;
procedure TForm1.ShowCdKey;
var
plain_pk: array[0..32] of char;
cryp_pk: array[0..15] of char;
d: Integer;
p: STring;
begin
p := RegGetBinary;
d :=0;
while d < 32 do begin
    SScanf(Pchar(copy(p,1,2)),'%02x',[@cryp_pk[d]]);
    delete(p,1,2);
    inc(d);
    end;
    plain_pk[d]:=#0;
    DecodeProdKey(plain_pk,cryp_pk,29,15);
    Edit2.Text := StrPas(plain_PK);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
ClientHEight := 112;
ClientWIdth := 425;
ShowCdKey;
end;

end.
 